﻿//
// NTFS - Myriadbits .NET NTFS library. 
// Fast MFT reader.
// Copyright (C) 2014 Myriadbits, Jochem Bakker
//
// This program is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program.  If not, see <http://www.gnu.org/licenses/>.
//
// For more information, contact me at: info@myriadbits.com
//

using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Diagnostics;


namespace Myriadbits.NTFS
{
	public class NTFSAttributeStandardInformation : NTFSAttribute
	{
		public NTFSAttributeStandardInformation(DataBuffer buffer, int offset)
			: base(buffer, offset)
		{
		}

		public DateTime FileCreationTime { get { return this.GetDateTime(0x00); } }
		public DateTime FileAlteredTime { get { return this.GetDateTime(0x08); } }
		public DateTime MFTChangedTime { get { return this.GetDateTime(0x10); } }
		public DateTime FileReadTime { get { return this.GetDateTime(0x18); } }
		public uint DOSFilePermissions { get { return this.GetUInt(0x20); } }
	}
}
